include("../src/helper.jl")
@testset "helper.jl" begin
    @testset "list_nw" begin
        @test length(list_nw(["A", "B", "C", "D", "E", "F", "G", "H"])) == 2520 #(N2222)
        @test length(list_nw(["A", "B", "C", "D", "E", "F", "G"])) == 2520 #(N1222, N2122, N2212, N2221)
        @test length(list_nw(["A", "B", "C", "D", "E", "F"])) == 1080 #(N1122, N1212, N1221, N2112, N2121, N2211)
        @test length(list_nw(["A", "B", "C", "D", "E"])) == 240 #(N1112, N1121, N1211, N2111)
  end
  
  @test compare_nw([("1", "2"), ("3", "4"), ("5", "6"), ("7", "8")],[("1", "2"), ("3", "4"), ("5", "6"), ("7", "9")]) == false
  @test compare_nw([("1", "2"), ("3", "4"), ("5", "6"), ("7", "8")],[("1", "2"), ("3", "4"), ("5", "6"), ("8", "7")]) == true     
  @test N_to_str([("1", "2"), ("3", "4"), ("5", "6"), ("7", "8", "9")]) == "[(1,2),(3,4),(5,6),(7,8,9)]"
  @test N_to_network([("1", "2"), ("3", "4"), ("5", "6"), ("7", "8")]) == "((7:1,8:1):4, (((3:1,4:1):2, ((1:1,2:1):1)#H1:1::0.7):1, (#H1:1::0.3,(5:1,6:1):2):1):1);"
  @test N_to_t([("1", "2"), ("3", "4"), ("5", "6"), ("7", "8")]) == [ "1", "2", "3", "4", "5", "6", "7", "8"]
  @test N_to_N_num([("1", "2"), ("3", "4"), ("5", "6"), ("7", "8")]) == "2222"
end